// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.batch;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Lot échantillonné ou lot composant une capture réelle. Une
 * capture ou un arbre d'échantillonnage sont en effet constitués
 * d'un ensemble de lots.
 * </p>
 */
public abstract class Batch
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -6355878249350290701L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant unique du lot.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.Short rankOrder;

    /**
     * <p>
     * Numéro d'ordre du lot.
     * </p>
     * <p>
     * Sert pour déterminer l'ordre de présentation des lots rattaché à
     * un même lot père.
     * </p>
     */
    public java.lang.Short getRankOrder()
    {
        return this.rankOrder;
    }

    public void setRankOrder(java.lang.Short rankOrder)
    {
        this.rankOrder = rankOrder;
    }

    private java.lang.Float subgroupCount;

    /**
     * <p>
     * Nombre de sous ensembles ayant servit à la quantification.
     * Attention : Il ne s'agit pas du nombre de lot fils.
     * </p>
     * <p>
     * Par exemple il pourra s'agir d'un nombre de caisse servant à
     * quantifié le lot.
     * </p>
     * <p>
     * Par exemple, pour une détermination de la quantification par les
     * volumes :
     * </p>
     * <p>
     * - nombre_sous_ensembles_quantifiés = 3
     * </p>
     * <p>
     * - poids moyen par sous-ensemble = 5 kg
     * </p>
     * <p>
     * => Poids total du lot = 3 x 5 = 15kg
     * </p>
     */
    public java.lang.Float getSubgroupCount()
    {
        return this.subgroupCount;
    }

    public void setSubgroupCount(java.lang.Float subgroupCount)
    {
        this.subgroupCount = subgroupCount;
    }

    private java.lang.Integer individualCount;

    /**
     * <p>
     * Nombre d'individus comptés.
     * </p>
     */
    public java.lang.Integer getIndividualCount()
    {
        return this.individualCount;
    }

    public void setIndividualCount(java.lang.Integer individualCount)
    {
        this.individualCount = individualCount;
    }

    private java.lang.Boolean childBatchsReplication = java.lang.Boolean.valueOf(false);

    /**
     * <p>
     * Indique si les lots fils sont des réplicats ou non. Attribut non
     * renseigné si un des lots père est rattaché à un taxon ou groupe
     * de taxon.
     * </p>
     */
    public java.lang.Boolean getChildBatchsReplication()
    {
        return this.childBatchsReplication;
    }

    public void setChildBatchsReplication(java.lang.Boolean childBatchsReplication)
    {
        this.childBatchsReplication = childBatchsReplication;
    }

    private java.lang.Boolean exhaustiveInventory = java.lang.Boolean.valueOf(false);

    /**
     * <p>
     * <html>
     * </p>
     * <p>
     * <head>
     * </p>
     * <p>
     * </head>
     * </p>
     * <p>
     * <body>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Indique si l'inventaire des esp&#232;ces scientifiques
     * (ReferenceTaxon) est
     * </p>
     * <p>
     * exhaustif ou non.Attribut non renseign&#233; si le lot ou un de
     * ses lots p&#232;re
     * </p>
     * <p>
     * est rattach&#233; &#224; un taxon.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Si l'inventaire est exhautif, il convient de remplir
     * <i>BatchExhautiveInventory</i>,
     * </p>
     * <p>
     * pour tracer sur quelle liste d'esp&#232;ces porte
     * l'exhaustivit&#233;. Si <i>BatchExhautiveInventory</i>
     * </p>
     * <p>
     * n'est pas renseign&#233;, alors l'exhautivit&#233; porte sur
     * toutes les esp&#232;ces.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * </body>
     * </p>
     * <p>
     * </html>
     * </p>
     */
    public java.lang.Boolean getExhaustiveInventory()
    {
        return this.exhaustiveInventory;
    }

    public void setExhaustiveInventory(java.lang.Boolean exhaustiveInventory)
    {
        this.exhaustiveInventory = exhaustiveInventory;
    }

    private java.lang.String comments;

    /**
     * 
     */
    public java.lang.String getComments()
    {
        return this.comments;
    }

    public void setComments(java.lang.String comments)
    {
        this.comments = comments;
    }

    private java.lang.String label;

    /**
     * <p>
     * Libellé du lot (besoin pour le flux d'échantillonnage ISCAX).
     * </p>
     * <p>
     * Pas encore utiliser, dans Allegro V2 et V3 lot 1.
     * </p>
     */
    public java.lang.String getLabel()
    {
        return this.label;
    }

    public void setLabel(java.lang.String label)
    {
        this.label = label;
    }



    private java.util.Collection<fr.ifremer.adagio.core.dao.data.batch.BatchExhaustiveInventory> batchExhaustiveInventories = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.batch.BatchExhaustiveInventory>();

    /**
     * <p>
     * Liste les niveaux d'exhautivité, c'est à dire les listes
     * concernés par l'éxhautivité.
     * </p>
     * <p>
     * Ces listes sont représentées par une niveau de priorité, définis
     * dans la stratégie (cf ReferenceTaxonStrategy)
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.batch.BatchExhaustiveInventory> getBatchExhaustiveInventories()
    {
        return this.batchExhaustiveInventories;
    }

    public void setBatchExhaustiveInventories(java.util.Collection<fr.ifremer.adagio.core.dao.data.batch.BatchExhaustiveInventory> batchExhaustiveInventories)
    {
        this.batchExhaustiveInventories = batchExhaustiveInventories;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.batch.Batch> childBatchs = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.batch.Batch>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.batch.Batch> getChildBatchs()
    {
        return this.childBatchs;
    }

    public void setChildBatchs(java.util.Collection<fr.ifremer.adagio.core.dao.data.batch.Batch> childBatchs)
    {
        this.childBatchs = childBatchs;
    }


    private fr.ifremer.adagio.core.dao.data.batch.Batch parentBatch;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.batch.Batch getParentBatch()
    {
        return this.parentBatch;
    }

    public void setParentBatch(fr.ifremer.adagio.core.dao.data.batch.Batch parentBatch)
    {
        this.parentBatch = parentBatch;
    }


    private fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag;

    /**
     * <p>
     * Niveau de qualité de la donnée.
     * </p>
     * <p>
     * "Non qualifiée" par défaut
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    public void setQualityFlag(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag)
    {
        this.qualityFlag = qualityFlag;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location location;

    /**
     * <p>
     * Zone de pêche.
     * </p>
     * <p>
     * Uniquement dans le cas ou l'opération unitaire n'est pas connue
     * (Exemple : lors des échantillonnage des ventes observées)
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getLocation()
    {
        return this.location;
    }

    public void setLocation(fr.ifremer.adagio.core.dao.referential.location.Location location)
    {
        this.location = location;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.produce.Produce>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> getProduces()
    {
        return this.produces;
    }

    public void setProduces(java.util.Collection<fr.ifremer.adagio.core.dao.data.produce.Produce> produces)
    {
        this.produces = produces;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement> quantificationMeasurements = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement>();

    /**
     * <p>
     * Liste des mesure de quantification du lot.
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement> getQuantificationMeasurements()
    {
        return this.quantificationMeasurements;
    }

    public void setQuantificationMeasurements(java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.QuantificationMeasurement> quantificationMeasurements)
    {
        this.quantificationMeasurements = quantificationMeasurements;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Batch))
        {
            return false;
        }
        final Batch that = (Batch)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

// Batch.java merge-point
    private Float weight = null;
    private Integer weightMethodId = null;
    private Float weightBeforeSampling = null;
    private Float indirectWeight = null;
    private Float elevateWeight = null;
    
  public Float getWeight() {
    return weight;
  }

  public void setWeightMethodId(Integer weightMethodId) {
    this.weightMethodId = weightMethodId;
  }
  public Integer getWeightMethodId() {
    return weightMethodId;
  }

  public void setWeight(Float weight) {
    this.weight = weight;
  }
  
  public Float getWeightBeforeSampling() {
    return weightBeforeSampling;
  }

  public void setWeightBeforeSampling(Float weightBeforeSampling) {
    this.weightBeforeSampling = weightBeforeSampling;
  }

  public Float getIndirectWeight() {
    return indirectWeight;
  }

  public void setIndirectWeight(Float indirectWeight) {
    this.indirectWeight = indirectWeight;
  }

  public Float getElevateWeight() {
    return elevateWeight;
  }

  public void setElevateWeight(Float elevateWeight) {
    this.elevateWeight = elevateWeight;
  }
}